:
# NAME:
#	xcat.sh - cat,zcat as needed
#
# SYNOPSIS:
#	xcat.sh "file" ...
#
#	. xcat.sh
#	xcat "file" ...
#
# DESCRIPTION:
#	This script provides a function xcat() which determines
#	whether each "file" needs cat,zcat,gzcat based on its
#	extention and builds maximally long command lines that will
#	``cat'' them apparopriately.
#	
# AUTHOR:
#	Simon J. Gerraty <sjg@crufty.net>

# RCSid:
#	$Id: xcat.sh,v 1.4 2002/01/11 00:52:50 sjg Exp $
#
#	@(#) Copyright (c) 1992,1996 Simon J. Gerraty
#
#	This file is provided in the hope that it will
#	be of use.  There is absolutely NO WARRANTY.
#	Permission to copy, redistribute or otherwise
#	use this file is hereby granted provided that 
#	the above copyright notice and this notice are
#	left intact. 
#      
#	Please send copies of changes and bug-fixes to:
#	sjg@crufty.net
#

xcat() {
	cmd=
	lcat=x
	for f in $*
	do
		case "$f" in
		*.Z) _cat=${ZCAT:-zcat};;
		*.gz) _cat=${GZCAT:-gzcat};;
		*) _cat=${CAT:-cat};;
		esac
		if [ $lcat = $_cat ]; then
			cmd="$cmd $f"
		else
			[ "$cmd" ] && $DOIT $cmd
			cmd="$_cat $f"
			lcat=$_cat
		fi
	done
	[ "$cmd" ] && $DOIT $cmd
}

case "$0" in
*xcat*) xcat $*;;
esac
